package sharecode.asynchronous;

import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;

import sharecode.core.model.Input;
import sharecode.core.model.Result;
import sharecode.exception.ShareCodeException;
import sharecode.message.ReplayMessage;
import sharecode.message.SharedCodeMessage;
import sharecode.util.GeneratorUUID;
import sharecode.util.SearchUtil;
import sharecode.util.Tracer;

public class MessageConsumer{
	
	private SharedCodeMessage replyMessage;
	
	@SuppressWarnings("unused")
	private SharedCodeMessage requestMessage;
	
	/**
	 * Retrieves and removes the head of the requestQueue to requestMessage
	 * @param requestQueue
	 * @throws InterruptedException
	 * @throws ShareCodeException 
	 */
	public MessageConsumer(RequestQueue requestQueue) throws ShareCodeException{
		requestMessage = requestQueue.take();
	}
	
	/**
	 * 
	 * @return
	 * @throws ShareCodeException 
	 */
	public boolean consume() throws ShareCodeException{
		if (requestMessage == null)
			return false;
		
		Tracer.trace(this, "Consumed message "+requestMessage.getMessageId()+" to send to "+requestMessage.getRequestorId().getName());
		
		
		if ((requestMessage.getContent() !=null) && (requestMessage.getContent() instanceof Input)) {
			Input input = (Input) requestMessage.getContent();
			List retorno = SearchUtil.find(input,  new IProgressMonitor(){
				public void beginTask(String name, int totalWork) {	}
				public void done() {}
				public void internalWorked(double work) {}
				public boolean isCanceled() {return false;}
				public void setCanceled(boolean value) {}
				public void setTaskName(String name) {}
				public void subTask(String name) {}
				public void worked(int work) {}
				});
			
//			 TODO popular a mensagem com informacoes para o replier
			ReplayMessage replayMessage = new ReplayMessage();
			Result result = new Result();
			result.setResults(retorno);
			result.setInput(input);
			replayMessage.setContent(result);
			replayMessage.setCorrelationId(requestMessage.getMessageId());
			replayMessage.setRequestorId(requestMessage.getRequestorId());
			
			replayMessage.setTime(System.currentTimeMillis());
//			add a ID to the message
			replayMessage.setMessageId(GeneratorUUID.getInstance().geraUUID());
			
			//TODO analisar se essa variavel serve pra algo
			this.replyMessage=replayMessage;
			return true;
		} else 
			return false;

	}

	public SharedCodeMessage getMessage() {
		
		return replyMessage;
			
	}


}
