package sharecode.asynchronous;

import sharecode.exception.ShareCodeException;
import sharecode.util.Tracer;


public class QueueSession {

	private static QueueSession instance;
	private RequestQueue requestQueue;
	
	private QueueSession(){
		requestQueue = new RequestQueue();
		Tracer.trace(this, "Iniciou QueueSession");
	}
	
	public synchronized static QueueSession instance() {
		
		if(instance ==null)
			instance = new QueueSession();
		return instance;
	}

	public MessageProducer createProducer(RequestQueue requestQueue2) {
		
		MessageProducer producer = new MessageProducer(requestQueue2);

		return producer;
	}

	public MessageConsumer createConsumer(RequestQueue requestQueue) throws ShareCodeException {
		MessageConsumer consumer = new MessageConsumer(requestQueue);
		
		return consumer;
	}

	public RequestQueue getRequestQueue() {
		
		return requestQueue;
	}

}
