package sharecode.message;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import org.eclipse.ecf.core.identity.ID;
import org.eclipse.ecf.core.util.ECFException;

import sharecode.message.content.Content;

public abstract class SharedCodeMessage implements Serializable{
	
	private long time;
	private Content content;
	private Content correlationContent;
	
	/**
	 * A token in the reply that has the same value as the request ID in the request
	 */
	private String correlationId;

	/**
	 * A token in the request that uniquely identifies the request.
	 */
	private String messageId;
	private ID requestorId;


	
	
	/**
	 * 
	 * @return
	 * @throws IOException
	 * @throws ECFException
	 */
	public byte[] toByteArray() throws IOException, ECFException {
		ByteArrayOutputStream bouts = new ByteArrayOutputStream();
		ObjectOutputStream douts = new ObjectOutputStream(bouts);
		douts.writeObject(this);
		return bouts.toByteArray();
	}


	public Content getContent() {
		return content;
	}


	public void setContent(Content content) {
		this.content = content;
	}


	public long getTime() {
		return time;
	}


	public void setTime(long l) {
		this.time = l;
	}

	public String getCorrelationId() {
		return correlationId;
	}

	public void setCorrelationId(String correlationId) {
		this.correlationId = correlationId;
	}
	
	public String getRequestId() {
		return messageId;
	}

	public void setRequestId(String id) {
		this.messageId = id;
	}


	public ID getRequestorId() {
		return requestorId;
	}


	public void setRequestorId(ID requestorId) {
		this.requestorId = requestorId;
	}


	public String getMessageId() {
		return messageId;
	}


	public void setMessageId(String messageId) {
		this.messageId = messageId;
	}


	public Content getCorrelationContent() {
		return correlationContent;
	}


	public void setCorrelationContent(Content correlationContent) {
		this.correlationContent = correlationContent;
	}

}
