package sharecode.util;


import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import java.util.ResourceBundle;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;


public class ProjectListElement {

	IProject project;

	public ProjectListElement(IProject project) {
		super();
		this.project = project;	
	}

	public ProjectListElement(String name) {
		super();
//		this.project = project;	
	}

	public static IProject[] filterProjects(String license){
		
		if(license.trim().equals("All Linceses"))return getProjects();
		
		IProject [] projects = getProjects();
		List<IProject> selectedProjects = new ArrayList<IProject>(projects.length);
		
		for (IProject project : projects) {
			
			try {
				//TODO precisam estar no arquivo de properties do plugin
				InputStream is = project.getFolder("/.sharedcode").getFile("sharedcode.properties").getContents();
				
				Properties p = new Properties();
				p.load(is);
				
				String licenseProject = p.getProperty("license");
				
				//TODO precisa ser refeito
				if(license ==null) license="All Linceses";
				
				if(licenseProject.equals(license)){
					selectedProjects.add(project);
					Tracer.trace(ProjectListElement.class, "Find the Project "+project.getName()+" to license "+license);
				}				
				
			} catch (CoreException e) {
				// TODO Tratar log
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Tratar log
				e.printStackTrace();
			} 
		}
		
		return selectedProjects.toArray(new IProject[selectedProjects.size()]);
	}



	public String toString() {
		return getID(project);	
	}
	
	public String getID() {
		return getID(project);	
	}
	
	static protected String getID(IProject project) {
		return project.getName();
	}
	
	static public List stringsToProjectsList(List projectIdList) {
		IWorkspaceRoot root= ResourcesPlugin.getWorkspace().getRoot();
		IProject[] projects = root.getProjects();
 		
		List selectedProjects = new ArrayList();
		for(int i=0; i<projects.length; i++) {
			if(projectIdList.contains(getID(projects[i]))) {
				selectedProjects.add(new ProjectListElement(projects[i]));	
			}
		}

		return selectedProjects;
	}

	
	static public IProject[] getProjects() {
		IWorkspaceRoot root= ResourcesPlugin.getWorkspace().getRoot();
		IProject[] projects = root.getProjects();
		 		
		return projects;
	}
	
	static public List stringsToProjectsList() {
		
		IProject[] projects = getProjects();
		
		List projectsWorkspace = new ArrayList();
		for(int i=0; i<projects.length; i++) {
			
			projectsWorkspace.add(new ProjectListElement(projects[i]));	
			
		}
 		
		return projectsWorkspace;
	}
	/*
	 * @see Object#equals(Object)
	 */
	public boolean equals(Object obj) {
		if(obj instanceof ProjectListElement)
			return this.getID().equals(((ProjectListElement)obj).getID());

		return false;
	}

	/*
	 * @see Object#hashCode()
	 */
	public int hashCode() {
		return this.getID().hashCode();
	}

	/**
	 * Gets the project.
	 * @return Returns a IProject
	 */
	public IProject getProject() {
		return project;
	}


}